package com.banesco.module.payment_instruction_request.application.service;

import com.banesco.common.application.helper.MessageHelper;
import com.banesco.common.domain.exception.*;
import com.banesco.common.domain.model.*;
import com.banesco.module.payment_instruction_request.application.repository.ApiPrivateRepository;
import com.banesco.module.payment_instruction_request.application.usecase.PaymentInstructionRequestUseCase;
import com.banesco.module.payment_instruction_request.domain.dto.request.PaymentInstructionRequestRequest;
import com.banesco.module.payment_instruction_request.domain.dto.response.PaymentInstructionRequestResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import jakarta.ws.rs.core.Response;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class PaymentInstructionRequestService implements PaymentInstructionRequestUseCase {

    private final MessageHelper messageHelper;
    private final ApiPrivateRepository apiPrivateRepository;

    @Inject
    public PaymentInstructionRequestService(
        MessageHelper messageHelper,
        ApiPrivateRepository apiPrivateRepository
    ) {
        this.messageHelper = messageHelper;
        this.apiPrivateRepository = apiPrivateRepository;
    }

    @Override
    public Response execute(
        PaymentInstructionRequestRequest request
    ) {
        log.info("Iniciando ejecucion para el cliente: {}", request.getRecipientId());

        Response response;

        try {
            ApiResponse<PaymentInstructionRequestResponse> apiResponse = apiPrivate(request);

            response = messageHelper.handleSuccess(
                apiResponse.getData(),
                apiResponse.getStatusResponse().getStatusCode()
            );
        } catch (ApiPrivateException e) {
            log.warn("Excepcion de la api privada: {} -> {}", e.getStatusCode(), e.getMessage());
            response = messageHelper.handleException(HttpStatusCodeException.conflict(e.getStatusCode()));
        } catch (HttpStatusCodeException e) {
            log.error("Excepcion HTTP del api privada: {} - {}", e.getStatusCode(), e.getErrorCode());
            response = messageHelper.handleException(e);
        } catch (Exception e) {
            log.error("Excepcion generica del api privada: {}", e.getMessage());
            response = messageHelper.handleGenericException(e);
        }

        return response;
    }

    private ApiResponse<PaymentInstructionRequestResponse> apiPrivate(
        PaymentInstructionRequestRequest request
    ) {
        log.info("Ejecutando llamada al api privada: {}", request.getRecipientId());

        return new ApiResponse<>(
            PaymentInstructionRequestResponse.builder()
                .paymentInstructionTransaction(apiPrivateRepository.execute(request))
                .build(),
            messageHelper.createStatusResponse("200")
        );
    }
}